;
;  for SHARP POCKET COMPUTER PC-G850/S/V/VS
;

OFF_CATEGORY_NAME = 0
OFF_CATEGORY_OFF = 2
OFF_QUESTIONS = 4

hiscore = 0x05d0
quiz = 0x05d4

.area _CODE

main::
	; 
	call init_quiz

	; o萔
	ld B, #4

main_loop2:
	; WI
	push BC
	call rand
	and #0x07
	call set_category
	pop BC

main_loop:
	; o肷
	push BC
	call set_question
	pop BC
	ret C
	jr NZ, main_loop

	; sߔ?
	cp #4
	jr C, main_gameover

	; o萔cĂ邩?
	djnz main_loop2

	; I
	call cls
	ld HL, #msg_gameend
	jr main_gameend

main_gameover:
	; Q[I[o[
	ld HL, #msg_gameover
main_gameend:
	ld B, #9
	ld DE, #0x0207
	call 0xbff1
	call put_hiscore

	; nCXRA?
	ld HL, (#hiscore)
	ld BC, (#score)
	or A
	sbc HL, BC
	jr NC, main_last
	
	; nCXRA
	ld (#hiscore), BC
main_last:
	jp 0xbcfd

msg_gameover:
	.ascii /GAME OVER/
msg_gameend:
	.ascii /GAME END /

;
; Q[
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL:j
;
init_quiz:
	; , s, _
	ld HL, #0
	ld (#score), HL

	; f[^̐擪AhXݒ肷
	ld HL, #quiz
	call a7_init

	; 2R[h𓾂
	call a7_read
	inc A
	ld (#code_2c), A

	; R[h𓾂
	call decode
	ld (#dic_code), HL

	; 𓾂
	call decode

	; ǂݔ΂
init_quiz_loop2:
	ld A, H
	or L
	jr Z, init_quiz_skip
	call skipstr
	dec HL
	jr init_quiz_loop2

init_quiz_skip:
	ld HL, #category_data
	ld B, #8

init_quiz_loop:
	; W̐擪AhXۑ
	ld DE, (#a7_off)
	call ld_hl_de
	call skipstr
	
	; ̃ItZbgۑ
	call decode_de
	call ld_hl_de

	; ̐ۑ
	call decode_de
	call ld_hl_de
	djnz init_quiz_loop

	; ̐擪ۑ
	ld DE, (#a7_off)
	ld (#question_top), DE
	ret

;
; WI
;
; 
; A:W(0~7)
;
; o
; AF,BC,DE,HL:j
;
set_category:
	; _\
	push AF
	call cls
	call put_hiscore
	pop AF

	; , s񐔂
	ld HL, #0
	ld (#result), HL
	
	; W𓾂
	ld HL, #category_data
	call add_hl_6a
	ld E, (HL)
	inc HL
	ld D, (HL)
	inc HL

	; W\
	push HL
	ex DE, HL
	call a7_set
	ld DE, #0x0230
	call putstr
	call delay_long2
	pop HL

	; ItZbg𓾂
	ld E, (HL)
	inc HL
	ld D, (HL)
	inc HL

	; 萔𓾂
	ld A, (HL)
	ld (#questions), A
	
	; 擪̖܂ňړ
	ld HL, (#question_top)
	call a7_set
set_category_loop:
	ld A, D
	or E
	jr Z, set_category_skip
	dec DE
	call skip_quiz
	jr set_category_loop

set_category_skip:
	; 擪̃ItZbgۑ
	ld HL, (#a7_off)
	ld (#category_top), HL
	ret

;
; \
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL,HL':j
;
set_question:
	call cls

	; AhX̐擪ɂ
	ld HL, (#category_top)
	call a7_set

set_question_loop:
	; I
	call rand
	ld B, A
	ld A, (#questions)
	dec A
	cp B
	jr C, set_question_loop

	; ǂݔ΂
	inc B
	dec B
	jr Z, set_question_skip
set_question_loop2:
	call skip_quiz
	djnz set_question_loop2

set_question_skip:
	; \
	ld DE, #0
	ld BC, #144 * 3
	call putstrn
	call delay_long2

	; ۑ
	ld A, (#a7_off)
	ld (#answer), A

	; Iۑ
	ld HL, #choise
	ld B, #5
set_question_loop5:
	ld DE, (#a7_off)
	ld (HL), E
	inc HL
	ld (HL), D
	ld DE, #5
	add HL, DE
	call skipstr
	djnz set_question_loop5

	; IVbt
	ld DE, #choise
	ld B, #5
set_question_loop3:
	call rand
	and #0x07
	cp #5
	jr NC, set_question_loop3
	ld HL, #choise
	call add_hl_6a
	call swap2_de_hl
	inc DE
	inc DE
	inc DE
	inc DE
	djnz set_question_loop3
	
	; I\
	ld HL, #choise
	ld B, #5
set_question_loop4:
	push BC
	call get_choise
	ld A, E
	add A
	add E
	add A
	ld E, A
	ld A, B
	add A
	add B
	add A
	add #4
	ld C, A
	ld B, #0
	call putstrn
	call delay2
	pop BC
	djnz set_question_loop4

	; , s񐔂\
	call put_result

	; c莞Ԃ
	ld DE, #0x0a00

input_answer:
	dec DE

	; c莞Ԃ\
	push DE
	ld A, D
	ld (#time), A
	ld DE, #0x0510
	call putbcd1
	pop DE

	; ҂
	ld B, #6
input_answer_delay:
	call rand
	djnz input_answer_delay

	; ^CI[o[?
	ld HL, #msg_timeover
	ld A, D
	or E
	jr Z, input_answer_timeover

	; L[͂𓾂
	call 0xbe53
	jr NC, input_answer

	; BREAKL[?
	cp #0x51
	scf
	ret Z

	; 1~5L[?
	call 0xbe56
	sub #"1"
	cp #5
	jr NC, input_answer
	push AF
	exx
	ld H, A
	exx

	; ͂ꂽIȊO
	ld HL, #choise
	ld B, #5
input_answer_loop:
	push BC
	call get_choise
	exx
	cp H
	exx
	ld A, #" "
	call NZ, putasciis
	pop BC
	djnz input_answer_loop

	; ?
	pop AF
	ld HL, #choise
	call add_hl_6a
	ld A, (#answer)
	cp (HL)
	jr Z, input_answer_correct

	; s
	ld HL, #msg_incorrect
input_answer_timeover:
	ld DE, (#result)
	inc D
	jr input_answer_skip

input_answer_correct:
	; 
	ld A, (#time)
	inc A
	call add_score
	ld HL, #msg_correct
	ld DE, (#result)
	inc E
input_answer_skip:

	; , s̃bZ[W\
	ld (#result), DE
	ld B, #9
	ld DE, #0x0208
	call 0xbff1
	call put_result
	call delay_long

	; _\
	call put_score
	call delay_long2

	; I?
	ld DE, (#result)
	ld A, D
	add E
	cp #7
	ld A, E

	scf
	ccf
	ret

; Io
get_choise:
	ld A, (HL)
	inc HL
	push HL
	ld H, (HL)
	ld L, A
	call a7_set
	pop HL
	inc HL
	ld A, (HL)
	inc HL
	ld B, (HL)
	inc HL
	ld E, (HL)
	inc HL
	ld D, (HL)
	inc HL
	ret

; I
choise:
	.dw 0x0000
	.db 0
	.db 11
	.dw 0x0300
	
	.dw 0x0000
	.db 1
	.db 12
	.dw 0x030c
	
	.dw 0x0000
	.db 2
	.db 11
	.dw 0x0400
	
	.dw 0x0000
	.db 3
	.db 12
	.dw 0x040c
	
	.dw 0x0000
	.db 4
	.db 15
	.dw 0x0500

; EsbZ[W
msg_correct:
	.ascii / /
	.db 0xed
	.ascii /!!/
msg_incorrect:
	.ascii / /
	.db 0xf0
	.ascii /޲! /
msg_timeover:
	.db 0xf0
	.ascii /޶ݷ!/

;
; _Z
;
; 
; B:Zl
;
; o
; AF,BC:j
; HL:_
;
add_score:
	ld B, A
add_score_loop:
	call inc_score
	djnz add_score_loop
	ret

;
; _1Z
;
; 
; Ȃ
;
; o
; AF,BC:j
; HL:_
;
inc_score:
	ld HL, (#score)
	ld A, L
	inc A
	daa
	ld L, A
	ld A, H
	adc #0
	daa
	ld H, A
	ld (#score), HL
	ret

;
; ō_\
;
; 
; Ȃ
;
; o
; AD,B,DE,HL:j
;
put_hiscore:
	ld DE, #0x0500
	ld HL, #msg_hiscore
	ld B, #3
	call 0xbff1

	ld DE, #0x0503
	ld HL, (#hiscore)
	call _put_score

;
; _\
;
; 
; Ȃ
;
; o
; AD,B,DE,HL:j
;
put_score:
	ld DE, #0x050f
	ld HL, (#score)
_put_score:
	call putbcd4
	ld B, #5
	ld HL, #msg_score
	jp 0xbff1

msg_score:
	.ascii /0pts./
msg_hiscore:
	.ascii /HI:/

;
; 4BCD\
;
; 
; DE:ʒu
; HL:l
;
; o
; AF:j
;
putbcd4:
	push HL
	ld A, H
	call putbcd2
	pop HL
	ld A, L

;
; 2BCD\
;
; 
; DE:ʒu
; A:l
;
; o
; Ȃ
;
putbcd2:
	push AF
	rrca
	rrca
	rrca
	rrca
	call putbcd1
	pop AF

;
; 1̐l\
;
; 
; DE:ʒu
; A:l
;
; o
; Ȃ
;
putbcd1:
	and #0x0f
	add #"0"
	call 0xbe62
	inc E
	ret

;
; , s񐔂\
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL:j
;
put_result:
	; Q[W\
	ld B, #7
	ld A, #""
	ld DE, #0x0511
	call putasciis

	; 𐔂\
	ld HL, #result
	ld B, (HL)
	ld A, #0xed
	call putasciis

	; s񐔂\
	inc HL
	ld A, (HL)
	ld B, A
	neg
	add #24
	ld E, A
	ld A, #0xf0
	jr putasciis

;
; 1ǂݔ΂
;
; 
; Ȃ
;
; o
; AF,HL:j
;
skip_quiz:
	push BC

	ld B, #6
skip_quiz_loop:
	call skipstr
	djnz skip_quiz_loop

	pop BC
	ret

;
; ҂()
;
; 
; Ȃ
;
; o
; F,B:j
;
delay_long2:
	call delay_long
delay_long:
	ld B, #4
delay_long_loop:
	call delay
	djnz delay_long_loop
	ret

;
; ҂(Z)
;
; 
; Ȃ
;
; o
; Ȃ
;
delay2:
	call delay
delay:
	push AF
	push BC

	ld BC, #0
delay_loop:
	dec BC
	ld A, B
	or C
	jr NZ, delay_loop

	pop BC
	pop AF
	ret

;
; ʂ
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL:j
;
cls:
	ld A, #0x40
	out (#0x40), A

	xor A
	ld (#0x790d), A

	ld DE, #0x0000
	ld A, #" "
	ld B, #24 * 6

;
; 𕡐\
;
; 
; A:ASCIIR[h
; B:
; DE:ʒu
;
; o
; AF,B:j
;
putasciis:
	push DE
	push HL
	
	inc B
	dec B
	call NZ, 0xbfee
	
	pop HL
	pop DE
	ret

;
; add HL, n * A
;
; 
; A:l
; HL:l
;
; o
; F:j
; HL:Zꂽl
;
add_hl_6a:
	call add_hl_3a
add_hl_3a:
	call add_hl_a
add_hl_2a:
	call add_hl_a
add_hl_a:
	push BC

	ld B, #0
	ld C, A
	add HL, BC

	pop BC
	ret

;
; ex (DE++), (HL++)
;
; 
; DE:AhX1
; HL:AhX2
;
; o
; A:j
; DE:DE + 2
; HL:HL + 2
;
swap2_de_hl:
	call swap1_de_hl
swap1_de_hl:
	ld A, (HL)
	push AF
	ld A, (DE)
	ld (HL), A
	pop AF
	ld (DE), A
	inc DE
	inc HL
	ret

;
; ld (HL++), DE
;
; 
; DE:l
; HL:AhX
;
; o
; HL:AhX+2
;
ld_hl_de:
	ld (HL), E
	inc HL
	ld (HL), D
	inc HL
	ret

.area _DATA

category_data:
	.ds 6 * 8
question_top:
	.ds 2
category_top:
	.ds 2
questions:
	.ds 1
game_count:
	.ds 1
answer:
	.ds 1
result:
	.ds 2
score:
	.ds 2
time:
	.ds 1

; Copyright 2011 maruhiro
; All rights reserved. 
;
; Redistribution and use in source and binary forms, 
; with or without modification, are permitted provided that 
; the following conditions are met: 
;
;  1. Redistributions of source code must retain the above copyright notice, 
;     this list of conditions and the following disclaimer. 
;
;  2. Redistributions in binary form must reproduce the above copyright notice, 
;     this list of conditions and the following disclaimer in the documentation 
;     and/or other materials provided with the distribution. 
;
; THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
; FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

; eof
