;
; \
;

font = 0x05d2
tmp = 0x7f80

.area _CODE

;
; 1\
;
; 
; BC:\
; DE:W
; HL:R[h
;
; o
; AF:j
; BC:c\
; DE:̍W
;
putchar::
	push HL
	push BC

	; HL = R[h * 7
	ld C, L
	ld B, H
	add HL, HL
	add HL, HL
	add HL, HL
	sbc HL, BC

	; 7bitz̏Ԃۑ
	ld BC, (#a7_base)
	push BC
	ld BC, (#a7_address)
	push BC
	ld BC, (#a7_off)
	push BC
	ld A, (#a7_mask)
	push AF

	; tHgp^[̐擪Ɉړ
	push HL
	ld HL, (#font)
	call a7_init
	pop HL
	call a7_set

	; tHgp^[𓾂
	ld B, #7
	ld HL, #tmp - 1
putchar_loop:
	call a7_read
	inc HL
	ld (HL), A
	djnz putchar_loop
	inc HL
	ld (HL), #0

	; 7bitz̏Ԃ߂
	pop AF
	ld (#a7_mask), A
	pop BC
	ld (#a7_off), BC
	pop BC
	ld (#a7_address), BC
	pop BC
	ld (#a7_base), BC

	; tHgp^[̒𓾂
	ld BC, #0x0008
putchar_loop3:
	dec C
	jr Z, putchar_skip
	dec HL
	ld A, (HL)
	or A
	jr Z, putchar_loop3
putchar_skip:
	inc C

	; ?
	pop HL
	or A
	sbc HL, BC
	push HL
	jp M, putchar_last

	; KvȂs
	ld A, E
	add C
	cp #146
	jr C, putchar_skip2
	ld E, #0
	inc D
putchar_skip2:

	; ANZX\ɂȂ܂ő҂
	ld B, C
	ld C, #0x40
putchar_loop2:
	in A, (C)
	rlca
	jr C, putchar_loop2

	; YWݒ肷
	ld A, D
	and #0x07
	or #0xb0
	out (C), A

	; XW()ݒ肷
	ld A, E
	and #0x0f
	out (C), A

	; XW()ݒ肷
	ld A, E
	rrca
	rrca
	rrca
	rrca
	and #0x0f
	or #0x10
	out (C), A

	; ̕\ʒu֐i
	ld A, B
	add E
	ld E, A

	; \
	inc C
	ld HL, #tmp
	otir

putchar_last:
	pop BC
	pop HL
	ret

;
; \
;
; 
; DE:W
; (#a7_base):ZOg
; (#a7_address):AhX
; (#a7_mask):}XN
; (#a7_off):ItZbg
;
; o
; AF,BC:j
; DE:̍W
; (#a7_address):̃AhX
; (#a7_mask):̃}XN
; (#a7_off):̃ItZbg
;
putstr::
	ld BC, #0x7fff

;
; \
;
; 
; BC:\
; DE:W
; (#a7_base):ZOg
; (#a7_address):AhX
; (#a7_mask):}XN
; (#a7_off):ItZbg
;
; o
; AF:j
; BC:c\
; DE:̍W
; (#a7_address):̃AhX
; (#a7_mask):̃}XN
; (#a7_off):̃ItZbg
;
putstrn::
	push HL
	call _putstrn
	pop HL
	ret

_putstrn:
	; 𓾂
	call decode

putstrn_loop:
	push HL

	; \
	call decode
	
	; R[h?
	push HL
	push DE
	ld DE, (#dic_code)
	or A
	sbc HL, DE
	ld (#tmp), HL
	pop DE
	pop HL
	jr NC, putstrn_dic
	
	; \
	call putchar

putstrn_ret:
	pop HL

	; \炷
	dec HL
	ld A, H
	or L
	jr NZ, putstrn_loop
	ret

; ̕\
putstrn_dic:
	; ItZbgۑ
	ld HL, (#a7_off)
	push HL

	; ̐̕擪Ɉړ
	ld HL, #0
	call a7_set
	call decode
	call decode
	call decode
	ld HL, (#tmp)
putstrn_loop2:
	ld A, H
	or L
	jr Z, putstrn_skip
	dec HL
	call skipstr
	jr putstrn_loop2

putstrn_skip:
	; \
	call _putstrn

	; ItZbg߂
	pop HL
	call a7_set
	jr putstrn_ret

;
; ǂ݂Ƃ΂
;
; 
; (#a7_base):ZOg
; (#a7_address):AhX
; (#a7_mask):}XN
; (#a7_off):ItZbg
;
; o
; AF:j
; (#a7_address):̃AhX
; (#a7_mask):̃}XN
; (#a7_off):̃ItZbg
;
skipstr::
	push BC
	push HL

	ld A, (#code_2c)
	ld C, A

	; 𓾂
	call decode
	ld B, L

	; ǂݔ΂
skipstr_loop:
	call a7_read
	cp C
	call NC, a7_read
	djnz skipstr_loop

	pop HL
	pop BC
	ret

.area _DATA

dic_code::
	.ds 2

; Copyright 2011 maruhiro
; All rights reserved. 
;
; Redistribution and use in source and binary forms, 
; with or without modification, are permitted provided that 
; the following conditions are met: 
;
;  1. Redistributions of source code must retain the above copyright notice, 
;     this list of conditions and the following disclaimer. 
;
;  2. Redistributions in binary form must reproduce the above copyright notice, 
;     this list of conditions and the following disclaimer in the documentation 
;     and/or other materials provided with the distribution. 
;
; THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
; FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

; eof
